﻿Public Class Form1
    ' マウスボタンの押下処理
    Private Sub RichTextBox1_MouseDown(ByVal sender As Object, _
                                       ByVal e As System.Windows.Forms.MouseEventArgs) _
                                   Handles RichTextBox1.MouseDown
        ' マウスボタンの判定
        If e.Button <> Windows.Forms.MouseButtons.Right Then
            Exit Sub
        End If

        ' メニュー項目の生成
        Dim cutMenu As New ToolStripMenuItem( _
                        "切り取り(&T)", Nothing, AddressOf CutMenu_Click)
        Dim copyMenu As New ToolStripMenuItem( _
                        "コピー(&C)", Nothing, AddressOf CopyMenu_Click)
        Dim pasteMenu As New ToolStripMenuItem( _
                        "貼り付け(&P)", Nothing, AddressOf PasteMenu_Click)
        Dim separatorMenu As New ToolStripSeparator()
        Dim fontMenu As New ToolStripMenuItem("サイズと色(&F)")
        Dim sizeBox As New ToolStripTextBox()
        Dim colorList As New ToolStripComboBox()

        ' サイズメニューのTextBoxの初期化
        With sizeBox
            .BackColor = Color.AliceBlue
            .Size = New Size(30, 25)
            .TextBoxTextAlign = HorizontalAlignment.Right
            .Text = RichTextBox1.SelectionFont.Size
        End With
        AddHandler sizeBox.KeyDown, AddressOf SizeBox_KeyDown

        ' 色メニューのComboBoxの初期化
        Dim listItems As String() = {"（色の選択）", "黒色", "青色", "赤色"}
        With colorList
            .BackColor = Color.AliceBlue
            .Size = New Size(100, 25)
            .DropDownStyle = ComboBoxStyle.DropDownList
            .Items.AddRange(listItems)
            .SelectedIndex = 0
        End With
        AddHandler colorList.SelectedIndexChanged, _
                                    AddressOf ColorList_SelectedIndexChanged

        ' メニュー項目の作成
        ContextMenuStrip1.Items.Clear()
        ContextMenuStrip1.Items.AddRange(New ToolStripItem() _
                            {cutMenu, copyMenu, pasteMenu, separatorMenu, fontMenu})
        fontMenu.DropDownItems.AddRange(New ToolStripItem() {sizeBox, colorList})

        ' メニューの割り当て
        RichTextBox1.ContextMenuStrip = ContextMenuStrip1
    End Sub

    ' 切り取りメニューの選択処理
    Private Sub CutMenu_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs)
        RichTextBox1.Cut()
    End Sub

    ' コピーメニューの選択処理
    Private Sub CopyMenu_Click(ByVal sender As System.Object, _
                               ByVal e As System.EventArgs)
        RichTextBox1.Copy()
    End Sub

    ' 貼り付けメニューの選択処理
    Private Sub PasteMenu_Click(ByVal sender As System.Object, _
                                ByVal e As System.EventArgs)
        RichTextBox1.Paste()
    End Sub

    ' サイズの変更処理
    Private Sub SizeBox_KeyDown(ByVal sender As Object, _
                                ByVal e As System.Windows.Forms.KeyEventArgs)
        If e.KeyData = Keys.Enter Then
            Dim sizeValue As Single
            If Single.TryParse(sender.Text, sizeValue) Then
                With RichTextBox1
                    .SelectionFont = New Font(.SelectionFont.Name, sizeValue)
                    .ContextMenuStrip.Close()
                End With
            End If
            e.SuppressKeyPress = True
        End If
    End Sub

    ' 色の変更処理
    Private Sub ColorList_SelectedIndexChanged(ByVal sender As System.Object, _
                                               ByVal e As System.EventArgs)
        With RichTextBox1
            Select Case sender.Text
                Case "黒色"
                    .SelectionColor = Color.Black
                Case "青色"
                    .SelectionColor = Color.Blue
                Case "赤色"
                    .SelectionColor = Color.Red
            End Select
            .ContextMenuStrip.Close()
        End With
    End Sub
End Class
