﻿Public Class Form1
    ' フォームのロード処理
    Private Sub Form1_Load(ByVal sender As System.Object, _
                           ByVal e As System.EventArgs) Handles MyBase.Load
        With FileSystemWatcher1
            .EnableRaisingEvents = False
            .IncludeSubdirectories = True
            .Filter = "*.*"
            .NotifyFilter = System.IO.NotifyFilters.FileName Or _
                            System.IO.NotifyFilters.DirectoryName Or _
                            System.IO.NotifyFilters.LastWrite
        End With
    End Sub

    ' 監視開始ボタンの押下処理
    Private Sub Button1_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) Handles Button1.Click
        Try
            FileSystemWatcher1.Path = TextBox1.Text
            FileSystemWatcher1.EnableRaisingEvents = True
        Catch ex As Exception
            MessageBox.Show(ex.Message, "監視開始")
        End Try
    End Sub

    ' 監視終了ボタンの押下処理
    Private Sub Button2_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) Handles Button2.Click
        FileSystemWatcher1.EnableRaisingEvents = False
    End Sub

    ' ファイルまたはフォルダー変更時の処理
    Private Sub FileSystemWatcher1_Changed(ByVal sender As System.Object, _
                                           ByVal e As System.IO.FileSystemEventArgs) _
                                       Handles FileSystemWatcher1.Changed
        ListBox1.Items.Add("【変更】" & e.FullPath)
    End Sub

    ' ファイルやフォルダーの作成時処理
    Private Sub FileSystemWatcher1_Created(ByVal sender As Object, _
            ByVal e As System.IO.FileSystemEventArgs) Handles FileSystemWatcher1.Created
        ListBox1.Items.Add("【作成】" & e.FullPath)
    End Sub

    ' ファイルやフォルダーの削除時処理
    Private Sub FileSystemWatcher1_Deleted(ByVal sender As Object, _
            ByVal e As System.IO.FileSystemEventArgs) Handles FileSystemWatcher1.Deleted
        ListBox1.Items.Add("【削除】" & e.FullPath)
    End Sub

    ' ファイルやフォルダーの名前変更時処理
    Private Sub FileSystemWatcher1_Renamed(ByVal sender As Object, _
            ByVal e As System.IO.RenamedEventArgs) Handles FileSystemWatcher1.Renamed
        ListBox1.Items.Add("【名前変更】" & e.FullPath)
    End Sub

    ' 内部バッファーのオーバーフロー時処理
    Private Sub FileSystemWatcher1_Error(ByVal sender As Object, _
            ByVal e As System.IO.ErrorEventArgs) Handles FileSystemWatcher1.Error
        ListBox1.Items.Add("【オーバーフロー】" & e.GetException.Message)
    End Sub
End Class
